// #Sireum

package TempControlMixedUI

import org.sireum._
import art._
import art.PortMode._
import art.DispatchPropertyProtocol._
import art.Art.BridgeId._
import art.Art.PortId._

// Do not edit this file as it will be overwritten if HAMR codegen is rerun

object Arch {
  val TempControlSystem_i_Instance_tcproc_tempSensor : TempControlMixedUI.TempSensor.TempSensor_i_tcproc_tempSensor_Bridge = {
    val currentTemp = Port[TempSensor.Temperature_i] (id = portId"0", name = "TempControlSystem_i_Instance_tcproc_tempSensor_currentTemp", mode = DataOut)
    val tempChanged = Port[art.Empty] (id = portId"1", name = "TempControlSystem_i_Instance_tcproc_tempSensor_tempChanged", mode = EventOut)

    TempControlMixedUI.TempSensor.TempSensor_i_tcproc_tempSensor_Bridge(
      id = bridgeId"0",
      name = "TempControlSystem_i_Instance_tcproc_tempSensor",
      dispatchProtocol = Periodic(period = 1000),
      dispatchTriggers = None(),

      currentTemp = currentTemp,
      tempChanged = tempChanged
    )
  }
  val TempControlSystem_i_Instance_tcproc_fan : TempControlMixedUI.CoolingFan.Fan_i_tcproc_fan_Bridge = {
    val fanCmd = Port[CoolingFan.FanCmd.Type] (id = portId"2", name = "TempControlSystem_i_Instance_tcproc_fan_fanCmd", mode = EventIn)
    val fanAck = Port[CoolingFan.FanAck.Type] (id = portId"3", name = "TempControlSystem_i_Instance_tcproc_fan_fanAck", mode = EventOut)

    TempControlMixedUI.CoolingFan.Fan_i_tcproc_fan_Bridge(
      id = bridgeId"1",
      name = "TempControlSystem_i_Instance_tcproc_fan",
      dispatchProtocol = Sporadic(min = 1000),
      dispatchTriggers = None(),

      fanCmd = fanCmd,
      fanAck = fanAck
    )
  }
  val TempControlSystem_i_Instance_tcproc_tempControl : TempControlMixedUI.TempControlSystem.TempControl_i_tcproc_tempControl_Bridge = {
    val currentTemp = Port[TempSensor.Temperature_i] (id = portId"4", name = "TempControlSystem_i_Instance_tcproc_tempControl_currentTemp", mode = DataIn)
    val fanAck = Port[CoolingFan.FanAck.Type] (id = portId"5", name = "TempControlSystem_i_Instance_tcproc_tempControl_fanAck", mode = EventIn)
    val setPoint = Port[TempControlSystem.SetPoint_i] (id = portId"6", name = "TempControlSystem_i_Instance_tcproc_tempControl_setPoint", mode = EventIn)
    val fanCmd = Port[CoolingFan.FanCmd.Type] (id = portId"7", name = "TempControlSystem_i_Instance_tcproc_tempControl_fanCmd", mode = EventOut)
    val tempChanged = Port[art.Empty] (id = portId"8", name = "TempControlSystem_i_Instance_tcproc_tempControl_tempChanged", mode = EventIn)

    TempControlMixedUI.TempControlSystem.TempControl_i_tcproc_tempControl_Bridge(
      id = bridgeId"2",
      name = "TempControlSystem_i_Instance_tcproc_tempControl",
      dispatchProtocol = Sporadic(min = 1000),
      dispatchTriggers = None(),

      currentTemp = currentTemp,
      fanAck = fanAck,
      setPoint = setPoint,
      fanCmd = fanCmd,
      tempChanged = tempChanged
    )
  }
  val TempControlSystem_i_Instance_tcproc_operatorInterface : TempControlMixedUI.TempControlSystem.OperatorInterface_i_tcproc_operatorInterface_Bridge = {
    val currentTemp = Port[TempSensor.Temperature_i] (id = portId"9", name = "TempControlSystem_i_Instance_tcproc_operatorInterface_currentTemp", mode = DataIn)
    val setPoint = Port[TempControlSystem.SetPoint_i] (id = portId"10", name = "TempControlSystem_i_Instance_tcproc_operatorInterface_setPoint", mode = EventOut)
    val tempChanged = Port[art.Empty] (id = portId"11", name = "TempControlSystem_i_Instance_tcproc_operatorInterface_tempChanged", mode = EventIn)

    TempControlMixedUI.TempControlSystem.OperatorInterface_i_tcproc_operatorInterface_Bridge(
      id = bridgeId"3",
      name = "TempControlSystem_i_Instance_tcproc_operatorInterface",
      dispatchProtocol = Periodic(period = 1000),
      dispatchTriggers = None(),

      currentTemp = currentTemp,
      setPoint = setPoint,
      tempChanged = tempChanged
    )
  }

  val ad : ArchitectureDescription = {

    ArchitectureDescription(
      components = IS[Art.BridgeId, Bridge] (TempControlSystem_i_Instance_tcproc_tempSensor, TempControlSystem_i_Instance_tcproc_fan, TempControlSystem_i_Instance_tcproc_tempControl, TempControlSystem_i_Instance_tcproc_operatorInterface),

      connections = IS[Art.ConnectionId, UConnection] (Connection(from = TempControlSystem_i_Instance_tcproc_tempSensor.currentTemp, to = TempControlSystem_i_Instance_tcproc_tempControl.currentTemp),
                                                       Connection(from = TempControlSystem_i_Instance_tcproc_tempSensor.currentTemp, to = TempControlSystem_i_Instance_tcproc_operatorInterface.currentTemp),
                                                       Connection(from = TempControlSystem_i_Instance_tcproc_tempSensor.tempChanged, to = TempControlSystem_i_Instance_tcproc_tempControl.tempChanged),
                                                       Connection(from = TempControlSystem_i_Instance_tcproc_tempSensor.tempChanged, to = TempControlSystem_i_Instance_tcproc_operatorInterface.tempChanged),
                                                       Connection(from = TempControlSystem_i_Instance_tcproc_fan.fanAck, to = TempControlSystem_i_Instance_tcproc_tempControl.fanAck),
                                                       Connection(from = TempControlSystem_i_Instance_tcproc_tempControl.fanCmd, to = TempControlSystem_i_Instance_tcproc_fan.fanCmd),
                                                       Connection(from = TempControlSystem_i_Instance_tcproc_operatorInterface.setPoint, to = TempControlSystem_i_Instance_tcproc_tempControl.setPoint))
    )
  }
}
